#ifndef MENU_H
#define MENU_H

enum{
	STATE_SLOT_MAX=9,
	DEF_COLOR0=0x9063,
	DEF_COLOR1=RGB(85,85,95),
	DEF_COLOR2=RGB(105,105,115),
	DEF_COLOR3=0xffff,
};

typedef struct
{
	int buttons;
	int n;
} S_BUTTON;

#define VERRIN "1.28"
#define VERCNF "RINv1.27"

typedef struct
{
	char vercnf[16];
	int screensize;
	int gb_type;
	int gb_palette;
	int frameskip;
	int vsync;
	int sound;
	int sound_buffer;
	unsigned long color[4];
	int bgbright;
	int analog2dpad;
	int thumb;
	int cpu_clock;
	char lastpath[256];
	unsigned char bScreenSizes[16]; //]Ɋm
	unsigned char bGB_Pals[32]; //]Ɋm
	S_BUTTON skeys[32]; //]Ɋm
	int compress;
} SETTING;

extern SETTING setting, tmpsetting;
extern int QuickSlot, bTurbo, bBitmap;
extern unsigned short bgBitmap[];
extern unsigned short thumb_w[160*144];
extern const char *cpu_clocks[];

void save_config();
void load_config();
void set_gb_type();
int load_menu_bg();
void rin_frame(const char *msg0, const char *msg1);
void rin_menu(void);
int rin_MessageBox(const char *msg, int type);

#endif
